<script setup lang="ts">
import { IGame } from '~/models/game/game.type.js';
import { contentToIGame } from '~/models/game/game';
import { BoardApi } from 'vue3-chessboard';
import { faArrowLeft, faArrowRight, faArrowsRotate } from '@fortawesome/free-solid-svg-icons';
import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome';
import { parsePgn, goToMove } from '~/models/pgn/pgn';
import { IMoveColor, IPgn } from '~/models/pgn/pgn.type';
import { useGames } from '~/composable/game';
const route = useRoute()

const game = ref<IGame>(contentToIGame(await queryContent(route.path).findOne()))

const { gamesByTournament } = await useGames()

const currentTournamentGames = computed(() => gamesByTournament(game.value.tournament))

const currentMove = ref<number>(0)
const currentColor = ref<IMoveColor>('black')

const parsedPgn = ref<IPgn>()
onMounted(() => {
  parsedPgn.value = parsePgn(game.value.pgn)
})

const boardAPI = ref<BoardApi>();

const handleBoardLoaded = async (board: BoardApi) => {
  boardAPI.value = board
  if (game.value.my_color === 'black') boardAPI.value.toggleOrientation()
}

const handleMoveClicked = (moveNumber: number, moveColor: IMoveColor) => {
  const slicedPgn = goToMove(game.value.pgn, moveNumber, moveColor)
  boardAPI.value?.loadPgn(slicedPgn)
  currentMove.value = moveNumber
  currentColor.value = moveColor
}

const handleTurn = () => {
  boardAPI.value?.toggleOrientation()
}

const handleReset = () => {
  boardAPI.value?.resetBoard()
  currentMove.value = 0
  currentColor.value = 'white'
}

const handlePrevious = () => {
  currentColor.value === 'white' && currentMove.value--
  currentColor.value = currentColor.value === 'white' ? 'black' : 'white'
  const slicedPgn = goToMove(game.value.pgn, currentMove.value, currentColor.value)
  boardAPI.value?.loadPgn(slicedPgn)
}

const handleNext = () => {
  currentColor.value === 'black' && currentMove.value++
  currentColor.value = currentColor.value === 'white' ? 'black' : 'white'
  const slicedPgn = goToMove(game.value.pgn, currentMove.value, currentColor.value)
  boardAPI.value?.loadPgn(slicedPgn)
}

</script>

<template>
  <main class="md:container md:mx-auto h-full w-full">
    <div class="p-5 text-justify">
      <ContentDoc />
    </div>
    <div v-if="game.type === 'tournament'">
      <UiTable :games="currentTournamentGames"></UiTable>
    </div>
    <div 
      v-if="game.type ==='game'"
      class="flex gap-6 justify-center mt-8 flex-col sm:flex-row">
      <div class="flex flex-col items-center justify-center gap-2">
        <div class="flex justify-center items-center gap-2">
          <UiButton @clicked="handleTurn">
            <FontAwesomeIcon :icon="faArrowsRotate"></FontAwesomeIcon>
          </UiButton>
          <UiButton @clicked="handlePrevious" :disabled="currentMove === 0">
            <FontAwesomeIcon :icon="faArrowLeft"></FontAwesomeIcon>
          </UiButton>
          <UiButton @clicked="handleNext" :disabled="parsedPgn &&
            currentMove === parsedPgn.length
            && currentColor === 'black'">
            <FontAwesomeIcon :icon="faArrowRight"></FontAwesomeIcon>
          </UiButton>
          <LichessLink v-if="game.lichess" :link="game.lichess"></LichessLink>
        </div>
        <ChessBoard @board-loaded="handleBoardLoaded" />

      </div>
      <PGNTable v-if="parsedPgn" @clicked="handleMoveClicked" @reset="handleReset" :pgn="parsedPgn"
        :moveNumber="currentMove" :moveColor="currentColor" />
    </div>
  </main>
</template>
